/**
 * 
 */
package org.gcube.resourcemanagement.model.reference.entities.resources;

import org.gcube.informationsystem.types.annotations.Abstract;
import org.gcube.informationsystem.types.annotations.ResourceSchema;
import org.gcube.informationsystem.types.annotations.ResourceSchemaEntry;
import org.gcube.resourcemanagement.model.impl.entities.resources.ActorImpl;
import org.gcube.resourcemanagement.model.reference.entities.facets.ContactFacet;
import org.gcube.resourcemanagement.model.reference.entities.facets.ContactReferenceFacet;
import org.gcube.resourcemanagement.model.reference.relations.consistsof.HasContact;
import org.gcube.resourcemanagement.model.reference.relations.consistsof.IsIdentifiedBy;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

/**
 * @author Luca Frosini (ISTI - CNR)
 * https://wiki.gcube-system.org/gcube/Facet_Based_Resource_Model#Actor
 */
@Abstract
@JsonDeserialize(as=ActorImpl.class)
@ResourceSchema({
	@ResourceSchemaEntry(consistOfType=IsIdentifiedBy.class, targetFacetType=ContactFacet.class, min=1),
	@ResourceSchemaEntry(consistOfType=HasContact.class, targetFacetType=ContactFacet.class),
	@ResourceSchemaEntry(targetFacetType=ContactReferenceFacet.class)
})
public interface Actor extends GCubeResource {
	
	public static final String NAME = "Actor"; // Actor.class.getSimpleName();
	public static final String DESCRIPTION = "Any entity (human or machine) playing an active role.";
	public static final String VERSION = "1.0.0";
	
}
