package org.gcube.resourcemanagement.model.reference.entities.resources;

import java.util.List;

import org.gcube.informationsystem.model.reference.entities.Facet;
import org.gcube.informationsystem.model.reference.entities.Resource;
import org.gcube.informationsystem.types.annotations.Abstract;
import org.gcube.informationsystem.types.annotations.ResourceSchema;
import org.gcube.informationsystem.types.annotations.ResourceSchemaEntry;
import org.gcube.resourcemanagement.model.impl.entities.resources.GCubeResourceImpl;
import org.gcube.resourcemanagement.model.reference.relations.consistsof.IsIdentifiedBy;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

/**
 * @author Luca Frosini (ISTI - CNR)
 */
@Abstract
@JsonDeserialize(as=GCubeResourceImpl.class)
@ResourceSchema({@ResourceSchemaEntry(consistOfType=IsIdentifiedBy.class, min=1)})
public interface GCubeResource extends Resource {
	
	public static final String NAME = "GCubeResource"; // GCubeResource.class.getSimpleName();
	public static final String DESCRIPTION = "Base Class for any gCube Resource";
	public static final String VERSION = "1.0.0";
	
	@JsonIgnore
	public List<? extends Facet> getIdentificationFacets();
	
	
	
}
